program dirhtm;
{Written by Hunter Beanland - 2000 - www.geocities.com/hbeanland }
{$I-}
{$M 2048,64000,400000}

uses tools,dos;

type
 ttoheap= string[180];

var
 h,n,i,maxdir:integer;
 nt,found:boolean;
 infile,outfile:text;
 line,temp,temp2,currdir:string;
 toheap: ^ttoheap;
 dir: array[1..5000] of pointer;

procedure stop(c:byte);
begin
 write('== Error ');
 if c=1 then writeln('writing file ==')
 else writeln('reading file ==');
 halt;
end;

procedure openfi(filen:string);
begin
  n:=ioresult;
  assign(infile,filen);
  setfattr(outfile,0);
  n:=doserror;
  filein:=filen;
  reset(infile);
  if ioresult<>0 then stop(5);
end;

procedure openfo(filen:string);
begin
  n:=ioresult;
  assign(outfile,filen);
  setfattr(outfile,0);
  n:=doserror;
  fileout:=filen;
  rewrite(outfile);
  if ioresult<>0 then stop(1);
end;

procedure addindex;
begin
  inc(maxdir);
  if maxdir=5001 then begin
    maxdir:=1;
    writeln('Warning= >5000 Dirs counted, some links may be lost');
    pause;
  end;
 if nt then begin
   temp2:=copy(line,40,length(line)-39)
 end
 else begin
  if length(line)<45 then begin
    temp2:=copy(line,1,12);
    while temp2[length(temp2)]=' ' do
      delete(temp2,length(temp2),1);
    if length(temp2)>8 then temp2[9]:='.';
    for i:=1 to length(temp2) do
      if temp2[i]=' ' then begin
        delete(temp2,i,1);
        i:=1-1;
      end;
  end
  else temp2:=copy(line,45,length(line)-44);
 end;
  temp2:=currdir+'\'+temp2;
  if temp2[1]='\' then delete(temp2,1,1);
  new(toheap);            {put in on the heap}
  toheap^:=temp2;
  dir[maxdir]:=toheap;   {store its heap address}
  str(maxdir,temp2);
  line:='<A HREF="#'+temp2+'">'+line;
  line:=line+'</A>';
end;

procedure dirlink;
begin
  found:=false;
  nt:=false;
  temp:=copy(line,17,length(line)-16);
  currdir:=temp;
  if maxdir<0 then begin
    maxdir:=0;
    exit;
  end;
  for i:=1 to maxdir do begin
    toheap:=dir[i];
    if temp=toheap^ then begin     {search the heap}
      str(i,temp2);
      i:=maxdir;
      found:=true;
      line:='<HR><B><A NAME="'+temp2+'"></A>'+line+'</B>';
    end;
  end;
  if not found then writeln('Warning= Orphaned Dir: ',temp);
end;

procedure dirlinknt;
begin
  found:=false;
  nt:=true;
  temp:=copy(line,18,length(line)-17);
  currdir:=temp;
  if maxdir<0 then begin
    maxdir:=0;
    exit;
  end;
  for i:=1 to maxdir do begin
    toheap:=dir[i];
    if temp=toheap^ then begin     {search the heap}
      str(i,temp2);
      i:=maxdir;
      found:=true;
      line:='<HR><B><A NAME="'+temp2+'"></A>'+line+'</B>';
    end;
  end;
  if not found then writeln('Warning= Orphaned Dir: ',temp);
end;

procedure history;
begin
  line:='<A HREF="javascript:history.go(-1)">'+line;
  line:=line+'</A>';
end;

begin
  writeln('Directory to HTML convertor  v1.4  Hunter Beanland');
  writeln('Construct input file by DIR/OGN/S >DIR.TXT when inside Windows');
  line:='DIR.TXT';
  temp:='DIR.HTM';
  if paramcount>0 then line:=paramstr(1)
  else writeln('Syntax: DIRHTM infile.txt outfile.htm');
  if paramcount>1 then temp:=paramstr(2);
  writeln('Input file: ',line);
  writeln('Output file: ',temp);
  openfi(line);
  openfo(temp);
  maxdir:=-1;
  temp:='';

  writeln(outfile,'<HTML>');
  if ioresult<>0 then stop(1);
  writeln(outfile,'<HEAD><TITLE>Directory Listing</TITLE></HEAD>');
  writeln(outfile,'<BODY BGCOLOR="#FFFFFF">');
  writeln(outfile,'<PRE>');

  while not eof(infile) do begin
    readln(infile,line);
    if ioresult<>0 then stop(2);
    if (pos('<DIR>',line)>0) and (line[1]<>'.') and (line[40]<>'.') then addindex;
    if copy(line,1,12)='Directory of' then dirlink;
    if copy(line,2,12)='Directory of' then dirlinknt;
    if (pos('<DIR>',line)>0) and (copy(line,1,2)='..') and (maxdir>0) then history;
    if (pos('<DIR>',line)>0) and (copy(line,40,2)='..') and (maxdir>0) then history;
    i:=pos('<DIR>',line);
    if i>0 then begin
      delete(line,i,5);
      insert('&lt;DIR&gt;',line,i);
    end;
    writeln(outfile,line);
  end;

  writeln(outfile,'</PRE></BODY></HTML>');
  close(outfile);
  for i:=1 to maxdir do begin
    toheap:=dir[i];
    dispose(toheap);
  end;
  writeln('Done');
end.